package VistaControlador;

import java.awt.Dimension;
import java.util.LinkedList;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

import Logica.*;

public class VistaAniadirVisualizar extends JPanel{
	private int x,y;
	private static final int altoCheck=28;
	protected Gestion gestiones;
	protected JButton boton;
	protected LinkedList<JCheckBox> transacciones;
	JPanel cuadro;
	JScrollPane panel;
	Menu menu;
	private ControladorAniadirVisualizar controlador;
	private static VistaPanelLateral panelLateral;
	public VistaAniadirVisualizar(Menu menu, Gestion gestion) {
		this.gestiones = gestion;
		this.transacciones = new LinkedList<JCheckBox>();
		this.menu = menu;
		this.x = 100;
		this.boton = new JButton("aniadir");
		this.add(boton);
		this.cuadro = new JPanel();
		this.panel = new JScrollPane(cuadro);
		this.panel.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
		this.panel.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		cuadro.setPreferredSize(new Dimension(x, y));
		panel.setPreferredSize(new Dimension(100,200));
		panel.setVisible(true);
		this.add(panel);
	}
	
	public static void setPanelLateral(VistaPanelLateral panel) {
		VistaAniadirVisualizar.panelLateral = panel;
	}
	
	public String getName() {
		return this.gestiones.getNombre();
	}
	
	void iniciarGestion() {
		for(Transaccion transaccion:this.gestiones.getElementos()) {
			 this.aniadirElemento(transaccion);
		}
	}
	
	public void aniadirElemento(String nombre, float dinero, ControladorAniadirVisualizar controlador) {
		Transaccion transaccion = new Transaccion(nombre, dinero,panelLateral.getDate());
		this.gestiones.aniadirGasto(transaccion);
		JCheckBox check = new JCheckBox(transaccion.toString());
		check.setSelected(true);
		check.setSize(new Dimension(x,VistaAniadirVisualizar.altoCheck));
		check.addActionListener(controlador);
		this.transacciones.add(check);
		this.cuadro.add(check);
		this.y += VistaAniadirVisualizar.altoCheck;
		cuadro.setPreferredSize(new Dimension(x, y));
		this.revalidate();
		this.repaint();
	}
	
	void eliminarDeseleccionados(){
		for(JCheckBox check:this.transacciones) {
			if(!check.isSelected()) {
				this.cuadro.remove(check);
				this.gestiones.eliminarTransaccion(check.getText());
				this.cuadro.revalidate();
				this.cuadro.repaint();
			}
		}
	}
	
	private void aniadirElemento(Transaccion transaccion) {
		JCheckBox check = new JCheckBox(transaccion.toString());
		check.setSelected(true);
		check.setSize(new Dimension(x,VistaAniadirVisualizar.altoCheck));
		check.addActionListener(this.boton.getActionListeners()[0]);
		this.transacciones.add(check);
		this.cuadro.add(check);
		this.y += VistaAniadirVisualizar.altoCheck;
		cuadro.setPreferredSize(new Dimension(x, y));
		this.revalidate();
		this.repaint();
	}
}
